<?php 

/**
  *	Portfolio Manager - Powered By Behance
  * Copyright (C) 2014 eLEOPARD Design Studios Pvt Ltd. All rights reserved

  * This program is free software: you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation, either version 3 of the License, or
  * (at your option) any later version.

  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.

  * You should have received a copy of the GNU General Public License
  * along with this program.  If not, see <http://www.gnu.org/licenses/>.

  * For any other query please contact us at contact[at]eleopard[dot]in
**/
?>
<?php
defined('_JEXEC') or die;

require_once JPATH_COMPONENT.'/helpers/lib/Be/Client.php';

//jimport('joomla.log.log');

class BPortManModelProject extends JModelAdmin
{
	protected $text_prefix = 'COM_BPORTMAN';

	public function getTable($type = 'Project', $prefix = 'BPortManTable', $config = array())
	{
		return JTable::getInstance($type, $prefix, $config);
	}

	public function getForm($data = array(), $loadData = true)
	{
		$app = JFactory::getApplication();
			
		$form = $this->loadForm('com_bportman.project', 'project', array('control' => 'jform', 'load_data' => $loadData));
		if (empty($form))
		{
			return false;
		}
			
		return $form;
	}


	protected function loadFormData()
	{
		$input = JFactory::getApplication()->input;
		$data = JFactory::getApplication()->getUserState('com_bportman.edit.project.data', array());
			
		if (empty($data))
		{
			$data = $this->getItem();
		}

		$bPrData= $input->get('b_project_data', array(), 'ARRAY');

		//JFactory::getApplication()->enqueueMessage( JObject::__toString($data) , 'notice');
		//JFactory::getApplication()->enqueueMessage(print_r($bPrData, true).'AFter msg' , 'notice');
		if(isset($bPrData) && $bPrData!=null)
		{
			$data->set('b_project_id',''.$bPrData['id'].'');
			$data->set('b_project_name',''.$bPrData['name'].'');
			$data->set('b_project_thumb',''.$bPrData['covers']['404'].'');
			$bFields ='';
			foreach ($bPrData['fields'] as $bField){ 
				$bFields = $bFields. ', ' . $bField;
			} 						
			$data->set('b_creative_fields',''.substr($bFields, 2).'');
			$data->set('b_create_date',''.date('Y-m-d H:i:s', $bPrData['created_on']).'');
			$data->set('b_modified_timestamp',$bPrData['modified_on']);
		}

			
		return $data;
	}

	protected function prepareTable($table)
	{
		$table->b_project_name = htmlspecialchars_decode($table->b_project_name, ENT_QUOTES);
		
		if (empty($table->ordering))
		{
			$db = JFactory::getDbo();
			$db->setQuery('SELECT MAX(ordering) FROM #__behance_projects');
			$max = $db->loadResult();

			$table->ordering = $max + 1;
		}
	}

	protected function canDelete($record)
	{
		if (!empty($record->id))
		{
			if ($record->state != -2)
			{
				return;
			}
			$user = JFactory::getUser();

			if ($record->catid)
			{
				return $user->authorise('core.delete',
    'com_bportman.category.'.(int) $record->catid);
			}
			else
			{
				return parent::canDelete($record);
			}
		}
	}

	protected function canEditState($record)
	{
		$user = JFactory::getUser();
			
		if (!empty($record->catid))
		{
			return $user->authorise('core.edit.state',
    'com_bportman.category.'.(int) $record->catid);
		}
		else
		{
			return parent::canEditState($record);
		}
	}

	private function getBPortManProject($projectID)
	{
		$params = JComponentHelper::getParams('com_bportman');
		$bAPIKey = $params->get('behance_api_key');	
			
		if(isset($bAPIKey) && $bAPIKey!='')
		{
			$clientID= trim($bAPIKey);//'41vqqO8jfneTZcNiuRzxYvoQqGcVZZxH';			
			try {
				$api = new Be_Client( $clientID);
				$data =  $api->getProject( $projectID , true);
				return $data;
			}
			catch(Exception $e)
			{
				return null;				
			}
		}
		else 
			return -1;
	}
	
	
	public function getBPortManProjectData()
	{
		
		$result = new stdClass();
		$input = JFactory::getApplication()->input;
		$behanceProjectId = $input->get('bp_search_id');
		$result->data = $this->getBPortManProject($behanceProjectId);
		if($result->data==null || !isset($result->data))
		{
			$result->status = 'F';
			$result->data = null;
			$result->msg = JText::_('COM_BPORTMAN_ERROR_CONTENT_NOT_RETREIVED');
		}
		else if($result->data == -1)
		{
			$result->status = 'F';
			$result->data = null;
			$result->msg= JText::_('COM_BPORTMAN_ERROR_CONFIG_NOT_SET');
		}		
		else 
		{
			$result->status = 'S';
			$result->msg = JText::_('COM_BPORTMAN_SUCCESS_CONTENT_RETREIVED');
		}
		return $result;

	}


	public function featured($pks, $value = 0)
	{
		// Sanitize the ids.
		$pks = (array) $pks;
		JArrayHelper::toInteger($pks);

		if (empty($pks))
		{
			$this->setError(JText::_('COM_BPORTMAN_NO_ITEM_SELECTED'));
			return false;
		}

		try
		{
			$db = $this->getDbo();
			$query = $db->getQuery(true)
			->update($db->quoteName('#__behance_projects'))
			->set('featured = ' . (int) $value)
			->where('id IN (' . implode(',', $pks) . ')');
			$db->setQuery($query);
			$db->execute();
		}
		catch (Exception $e)
		{
			$this->setError($e->getMessage());
			return false;
		}
		$this->cleanCache();

		return true;
	}
	
	
	public function synchronize($pks)
	{
		$pks = (array) $pks;
		JArrayHelper::toInteger($pks);
		
		if (empty($pks))
		{
			$this->setError(JText::_('COM_BPORTMAN_NO_ITEM_SELECTED'));
			return false;
		}
		
		try {
			
			$db = $this->getDbo();
			$query = $db->getQuery(true);
			
			$query->select(
					'a.id,'.
				    ' a.b_project_id, a.b_modified_timestamp'				
				);
								
			$query->from($db->quoteName('#__behance_projects').' AS a');
			$query->where('a.id IN (' . implode(',', $pks) . ')');	
			$db->setQuery($query);
			$projects = $db->loadObjectList();
			
			foreach($projects as $project)
			{
				if(!$this->updateProject($project->id, $project->b_project_id, $project->b_modified_timestamp))
					return false;
			}
						
		}
		catch (Exception $e)
		{
			$this->setError($e->getMessage());
			return false;
		}
		$this->cleanCache();
		
		return true;
		
	}
	
	private function updateProject($pk, $projectId, $modifiedTimeStamp)
	{
		$bPrData = $this->getBPortManProject($projectId);
		if($bPrData!=null && isset($bPrData) && $bPrData!=-1)
		{
			if($modifiedTimeStamp !=  $bPrData['"modified_on"'])
			{
				try {
					
				
				$db = $this->getDbo();
				$query = $db->getQuery(true);
				$query->update($db->quoteName('#__behance_projects'));
				$bFields ='';
					foreach ($bPrData['fields'] as $bField){ 
						$bFields = $bFields. ', ' . $bField;
					} 	
				// Fields to update.
				$fields = array(
	    			$db->quoteName('b_project_id') . ' = ' . $db->quote($bPrData['id']),
	    			$db->quoteName('b_project_name') . ' = ' . $db->quote($bPrData['name']),
	    			$db->quoteName('b_project_thumb') . ' = ' . $db->quote($bPrData['covers']['404']),	    			
	    			$db->quoteName('b_creative_fields') . ' = ' . $db->quote(substr($bFields, 2)),
	    			$db->quoteName('b_create_date') . ' = ' . $db->quote(date('Y-m-d H:i:s', $bPrData['created_on'])),
	    			$db->quoteName('b_modified_timestamp') . ' = ' .(int)$bPrData['modified_on']);
				
			
				$query->set($fields);	
				$query->where('id = '.$pk);
				$db->setQuery($query);
				$db->execute();	
				}
				catch(Exception $e)
				{
					return false;
				}
			}
			return true;
		}
		else 
			return false;
		
	}
	
	
	
	
}