<?php 

/**
  *	Portfolio Manager - Powered By Behance
  * Copyright (C) 2014 eLEOPARD Design Studios Pvt Ltd. All rights reserved

  * This program is free software: you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation, either version 3 of the License, or
  * (at your option) any later version.

  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.

  * You should have received a copy of the GNU General Public License
  * along with this program.  If not, see <http://www.gnu.org/licenses/>.

  * For any other query please contact us at contact[at]eleopard[dot]in
**/
?>
<?php
defined('_JEXEC') or die;

class BPortManTableProject extends JTable
{
	public function __construct(&$db)
	{
		parent::__construct('#__behance_projects', 'id', $db);
	}

	public function bind($array, $ignore = '')
	{
		if (isset($array['params']) && is_array($array['params']))
		{
			// Convert the params field to a string.
			$parameter = new JRegistry;
			$parameter->loadArray($array['params']);
			$array['params'] = (string)$parameter;
		}
		return parent::bind($array, $ignore);
	}

	public function load($pk = null, $reset = true)
	{
		if (parent::load($pk, $reset))
		{
			// Convert the params field to a registry.
			$params = new JRegistry;
			// loadJSON is @deprecated    12.1  Use loadString passing JSON as the format instead.
			// $params->loadJSON($this->params); 
			// "item" should not be present.			
			$params->loadString($this->params, 'JSON');

			$this->params = $params;
			return true;
		}
		else
		{
			return false;
		}
	}
	public function store($updateNulls = false)
	{
		return parent::store($updateNulls);
	}

	public function publish($pks = null, $state = 1, $userId = 0)
	{
		$k = $this->_tbl_key;
			
		JArrayHelper::toInteger($pks);
		$state = (int) $state;
			
		if (empty($pks))
		{
			if ($this->$k)
			{
				$pks = array($this->$k);
			}
			else
			{
				$this->setError(JText::_('JLIB_DATABASE_ERROR_NO_ROWS_SELECTED'));
				return false;
			}
		}
			
		$where = $k . '=' . implode(' OR ' . $k . '=', $pks);
			
		$query = $this->_db->getQuery(true)
		->update($this->_db->quoteName($this->_tbl))
		->set($this->_db->quoteName('state') . ' = ' . (int) $state)
		->where($where);
		$this->_db->setQuery($query);
		try
		{
			$this->_db->execute();
		}
		catch (RuntimeException $e)
		{
			$this->setError($e->getMessage());
			return false;
		}
		if (in_array($this->$k, $pks))
		{
			$this->state = $state;
		}
		$this->setError('');
			
		return true;
	}
}