<?php 

/**
  *	Portfolio Manager - Powered By Behance
  * Copyright (C) 2014 eLEOPARD Design Studios Pvt Ltd. All rights reserved

  * This program is free software: you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation, either version 3 of the License, or
  * (at your option) any later version.

  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.

  * You should have received a copy of the GNU General Public License
  * along with this program.  If not, see <http://www.gnu.org/licenses/>.

  * For any other query please contact us at contact[at]eleopard[dot]in
**/
?>
<?php
defined('_JEXEC') or die;

jimport('joomla.log.log');
 
class BPortManViewProject extends JViewLegacy
{
	protected $item;
	 
	protected $form;
	
	protected $input;
	
	protected $bPrData;
	
	protected $status;
	
	protected $msg;
	
	protected $showSearch;
	
	 
	public function display($tpl = null)
	{
		$document = JFactory::getDocument();
			
		
		
		$beResponse = array();
				
		$this->input = JFactory::getApplication()->input;
		
		$this->item = $this->get('Item');
				
		$isNew = ($this->item->id == 0);
		
		$this->status = '';
		$this->msg = '';

		if($isNew)
		{
			$this->showSearch = true;
			$customTask = $this->input->get('customtask');
			if(isset($customTask))
			{
				if($customTask == 'bpsearch')
				{
					$beResponse = $this->get('BPortManProjectData');
					
					$this->bPrData= $beResponse->data;
					$this->status = $beResponse->status;
					$this->msg =  $beResponse->msg;
					
					
								
					if($this->status == 'S')
					{		
						$this->input->set('b_project_data', $this->bPrData);			
						JFactory::getApplication()->enqueueMessage($this->msg);
					}
					else
						JFactory::getApplication()->enqueueMessage($this->msg, 'error');
				}
				else if($customTask == 'clear_search')
				{
					$this->input->set('bp_search_id','');			
				}
			}
			
			
		}
		else
		{
			$this->showSearch = false;
			$this->input->set('bp_search_id', $this->item->b_project_id);					
			$beResponse = $this->get('BPortManProjectData');
							
			$this->bPrData= $beResponse->data;
			$this->status = $beResponse->status;
			$this->msg =  $beResponse->msg;
			
			if($this->status == 'S')
			{			
				$this->input->set('b_project_data', $this->bPrData);
				JFactory::getApplication()->enqueueMessage($this->msg);
			}
			else
				JFactory::getApplication()->enqueueMessage($this->msg, 'error');
					
		}
		
		$this->form = $this->get('Form');
						 
		if (count($errors = $this->get('Errors')))
		{
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}
		 
		$this->addToolbar();
		
		
		//Adding CSS properties from behance		
		$document->addStyleSheet(JURI::root().'media/com_bportman/admin/css/bportman_admin.css');	
		$document->addStyleSheet(JURI::root().'media/com_bportman/common/css/material-design-iconic-font.min.css');
				
		$customCSS = ".bop-project-search-form {";
		$customCSS .= " max-width: 340px;";
		$customCSS .= " margin-left: auto;";
		$customCSS .= " margin-right: auto;";
		$customCSS .= " margin-top: 6%;}";
		
		$customCSS .= " .bop-information h4{";
		$customCSS .= " float: left;";
		$customCSS .= " text-align: center;";
		$customCSS .= " width: 100%;";
		$customCSS .= " font-weight:normal; }";		
		
		
		if($this->status == 'S'){
			
			$document->addStyleSheet(JURI::root().'media/com_bportman/common/css/project_view.css');			
			
			//Adding CSS properties from behance
			$customCSS = ".bpm-sr-attribution{ background-image: url('".JURI::root()."media/com_bportman/common/images/by.svg'); } ";
			$customCSS .= ".bpm-sr-noncommercial{ background-image: url('".JURI::root()."media/com_bportman/common/images/nc.svg'); }";				
			$customCSS .= ".bpm-sr-noderivatives{ background-image: url('".JURI::root()."media/com_bportman/common/images/nd.svg'); } ";
			$customCSS .= ".bpm-sr-sharealike{ background-image: url('".JURI::root()."media/com_bportman/common/images/sa.svg'); } ";
			$customCSS .= ".bpm-sr-zero{ background-image: url('".JURI::root()."media/com_bportman/common/images/zero.svg'); } ";
			
			if(isset($this->bPrData['canvas_width']) && !empty($this->bPrData['canvas_width'])){
				$customCSS .= "#bop-project-left { max-width:". $this->bPrData['canvas_width'] ."px; } ";
			}else{
				$customCSS .= "#bop-project-left { max-width:724px; } ";
			}
			
			$customCSS .= "#bop-project-left .bop-primary-project-content{";
			
			if(isset($this->bPrData['styles']['background']['color']))
				$customCSS .= "	background-color: #" . $this->bPrData['styles']['background']['color'] . ";";
				
			if(isset($this->bPrData['styles']['background']['image']['url']))
				$customCSS .= "background-image: url('" . $this->bPrData['styles']['background']['image']['url'] ."');";
	
			if(isset($this->bPrData['styles']['background']['image']['repeat'])){
				$customCSS .= "background-repeat: ". $this->bPrData['styles']['background']['image']['repeat'] . ";";
				
				if($this->bPrData['styles']['background']['image']['repeat'] == "repeat")
					$customCSS .= "background-size: auto";	
				else
					$customCSS .= "background-size: 100% auto;";
			}
				
	
			if(isset($this->bPrData['styles']['background']['image']['position']))
				$customCSS .= "background-position:". $this->bPrData['styles']['background']['image']['position'] .";";
					
			$customCSS .= " overflow-x: hidden; } ";
			
			if( isset( $this->bPrData['styles']['text']['title'] ) ){
				
				$customCSS .= " .bop-primary-project-content .title{";
				
				foreach($this->bPrData['styles']['text']['title'] as $pName => $pValue){
					$pName = str_replace('_','-' , $pName);
					$customCSS .= $pName.':'.$pValue.';';
				}
				
				$customCSS .= " }";
			}
			
			if( isset( $this->bPrData['styles']['text']['subtitle'] ) ){
				
				$customCSS .= " .bop-primary-project-content .sub-title{";
				
				foreach($this->bPrData['styles']['text']['subtitle'] as $pName => $pValue){
					$pName = str_replace('_','-' , $pName);
					$customCSS .= $pName.':'.$pValue.';';
				}
				
				$customCSS .= " }";
			}
			
			if( isset( $this->bPrData['styles']['text']['paragraph'] ) ){
				
				$customCSS .= " .bop-primary-project-content p, .bop-primary-project-content .main-text{";
				
				foreach($this->bPrData['styles']['text']['paragraph'] as $pName => $pValue){
					if( $pName != 'display') {
						$pName = str_replace('_','-' , $pName);
						$customCSS .= $pName.':'.$pValue.';';
					}
				}
				
				$customCSS .= " }";
			}
			
			if( isset( $this->bPrData['styles']['text']['caption'] ) ){
				
				$customCSS .= " .bop-primary-project-content .caption{";
				
				foreach($this->bPrData['styles']['text']['caption'] as $pName => $pValue){
					$pName = str_replace('_','-' , $pName);
					$customCSS .= $pName.':'.$pValue.';';
				}
				
				$customCSS .= " }";
			}
			
			if( isset( $this->bPrData['styles']['text']['link'] ) ){
				
				$customCSS .= " .bop-primary-project-content a{";
				
				foreach($this->bPrData['styles']['text']['link'] as $pName => $pValue){
					$pName = str_replace('_','-' , $pName);
					$customCSS .= $pName.':'.$pValue.';';
				}
				
				$customCSS .= " }";
			}		
		}	
		
		
		
		$document->addStyleDeclaration($customCSS);
		
		
		//ADding jquery
		JHtml::_('jquery.framework');
		
		$document->addScript(JURI::root().'media/com_bportman/admin/js/bportman_admin.js');
		
		//Adding script to load css dynamically based on the projecct container size
		if($this->status == 'S'){
			$document->addScriptDeclaration('			
				(function($){
					$(document).ready(function(){
					
						$("nav.bpm-top-info-nav li ul").hide().removeClass("fallback");
						$("nav.bpm-top-info-nav li").hover(function () {
							$("ul", this).stop().slideToggle(200);
						});
						
						$("#bop-waiting-popup").show();
						
						var cssFile = "";
						
						var width = $("#bop-all-wrapper").parent().innerWidth();
								
						if(width<=1024 && width>767)
							cssFile = "bop-responsive-768.css";
						else if(width<=767)
							cssFile = "bop-responsive-767.css";			
						
						if(cssFile != "")
						{
							var cssURL = "'.JURI::root().'media/com_bportman/common/css/" + cssFile;
							$.ajax({
							  url: cssURL					  
							}).done(function( data ) {
								$(\'<style type="text/css">\' + data + \'</style>\').appendTo("head");								
								$("#bop-waiting-popup").hide();
								$("#bop-project").animate({opacity : 1},1000);																			    
							});
						}else{									
							$("#bop-waiting-popup").hide();					
							$("#bop-project").animate({opacity : 1}, 1000);					
						}				
						
						initBPortMan();
						
					});
				})(jQuery);
			');	
		}
		
		parent::display($tpl);
	}
	 
	protected function addToolbar()
	{
		$this->input->set('hidemainmenu', true);
		
		$user = JFactory::getUser();
		$userId = $user->get('id');
		$isNew = ($this->item->id == 0);
		$canDo = BPortManHelper::getActions($this->item->catid, 0);
		
		 
		JToolbarHelper::title(JText::_('COM_BPORTMAN_MANAGER_PROJECT'), 'bportman');
		
		if(isset($this->bPrData) && $this->bPrData !=null)
		{
		
		 	if ($canDo->get('core.edit')||(count($user->getAuthorisedCategories('com_bportman', 'core.create'))))
			{
				JToolbarHelper::apply('project.apply');
				JToolbarHelper::save('project.save');
			}
			
			if (count($user->getAuthorisedCategories('com_bportman', 'core.create')))
			{
				JToolbarHelper::save2new('project.save2new');
			}
			
		/*	if (!$isNew && (count($user->getAuthorisedCategories('com_bportman', 'core.create')) > 0))
			{
				JToolbarHelper::save2copy('project.save2copy');
			}*/				
		}
					
		if (empty($this->item->id))
		{
			JToolbarHelper::cancel('project.cancel');
		}
		else
		{
			JToolbarHelper::cancel('project.cancel', 'JTOOLBAR_CLOSE');
		}
	}
	
	private function objectToArray($d) {
		if (is_object($d)) {
			// Gets the properties of the given object
			// with get_object_vars function
			$d = get_object_vars($d);
		}
 
		if (is_array($d)) {
			/*
			* Return array converted to object
			* Using __FUNCTION__ (Magic constant)
			* for recursive call
			*/
			return array_map(__FUNCTION__, $d);
		}
		else {
			// Return array
			return $d;
		}
	}
}